import java.awt.*;
import java.awt.event.*;
import java.lang.Math;
public class RangeReduction extends Frame
{  public int Iter; public double Err;
   public RangeReduction()
   {  setSize(800,500);
      addWindowListener(new WindowAdapter()
      { public void windowClosing(WindowEvent e){System.exit(0);}
      });
   }
   public double fn(double X)
   {  return (X * X - X - 2);   //@̕ɉׂ
   }
   public double solution( double EPS, double Left, double Right,int IterMax)
   { Iter = 0; double X1 = Left; double X2 = Right;  // 
     double X = 0; double Y = 0;
     double Err = EPS * 100;
     while( Err > EPS && Iter < IterMax)
     { Iter ++; X = (X1 + X2) / 2; Y = fn(X);
       if     (Math.abs(Y) < EPS) break;
       else if(Y > 0)             X2 = X;
       else                       X1 = X;
       Err = Math.abs(X2 - X1);
     }
     Err = Math.abs(Y); return X;
   }
   public void paint(Graphics g)
   {  setTitle("ԏk@"); double R = solution(0.0000001,0.0,3.0, 5000);
      g.drawString( " "+ R +" (JԂ = "+ Iter + ", 덷 = " + Err +")" ,20,50);
   } 
   public static void main(String[] args)
   {  Frame w = new RangeReduction();
      w.setVisible(true);
   }
}
